<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SRV_UbicacionClienteDet.xml */
/* Generado: 2020-08-18 04:21:30 */

/* Mantenimiento de los registros de la tabla SRV_UbicacionClienteDet */
abstract class BaseSRV_UbicacionClienteDetDP extends SRV_UbicacionClienteDetBV
{
    /* Constructor ( Establece los valores desde un objeto SRV_UbicacionClienteDetBN ) */
    public function __construct( SRV_UbicacionClienteDetBN $o_SRV_UbicacionClienteDetBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SRV_UbicacionClienteDetBN ) )
        {
            $this->setByBN( $o_SRV_UbicacionClienteDetBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SRV_UbicacionClienteDetBN */
    public function setByBN( SRV_UbicacionClienteDetBN $o_SRV_UbicacionClienteDetBN )
    {
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdUbicacionClienteH() ) )
        {
            $this->setIdUbicacionClienteH( $o_SRV_UbicacionClienteDetBN->getIdUbicacionClienteH() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdUbicacion() ) )
        {
            $this->setIdUbicacion( $o_SRV_UbicacionClienteDetBN->getIdUbicacion() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdTipoDocumento() ) )
        {
            $this->setIdTipoDocumento( $o_SRV_UbicacionClienteDetBN->getIdTipoDocumento() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_SRV_UbicacionClienteDetBN->getIdCompania() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_SRV_UbicacionClienteDetBN->getIdSucursal() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getNumeroDocumento() ) )
        {
            $this->setNumeroDocumento( $o_SRV_UbicacionClienteDetBN->getNumeroDocumento() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getDocumentoCod() ) )
        {
            $this->setDocumentoCod( $o_SRV_UbicacionClienteDetBN->getDocumentoCod() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getDocumentoSerie() ) )
        {
            $this->setDocumentoSerie( $o_SRV_UbicacionClienteDetBN->getDocumentoSerie() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getDocumentoNumero() ) )
        {
            $this->setDocumentoNumero( $o_SRV_UbicacionClienteDetBN->getDocumentoNumero() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_SRV_UbicacionClienteDetBN->getIdPersona() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getNombreCompleto() ) )
        {
            $this->setNombreCompleto( $o_SRV_UbicacionClienteDetBN->getNombreCompleto() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getMontoTotal() ) )
        {
            $this->setMontoTotal( $o_SRV_UbicacionClienteDetBN->getMontoTotal() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getEstado() ) )
        {
            $this->setEstado( $o_SRV_UbicacionClienteDetBN->getEstado() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SRV_UbicacionClienteDetBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SRV_UbicacionClienteDetBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SRV_UbicacionClienteDetBN->getFechaModificacion() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SRV_UbicacionClienteDetBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SRV_UbicacionClienteDetFN = new SRV_UbicacionClienteDetFN();
        $o_SRV_UbicacionClienteDetBN = $o_SRV_UbicacionClienteDetFN->selectByPk( $this->getIdUbicacionClienteH(), $this->getNumeroDocumento() );
        if ( is_null( $o_SRV_UbicacionClienteDetBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SRV_UbicacionClienteDet ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdUbicacionClienteH() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUbicacionClienteH";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdUbicacionClienteH()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUbicacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUbicacion";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdUbicacion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoCod() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DocumentoCod";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDocumentoCod()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoSerie() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DocumentoSerie";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDocumentoSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoNumero() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DocumentoNumero";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDocumentoNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPersona";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreCompleto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreCompleto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreCompleto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoTotal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoTotal";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SRV_UbicacionClienteDet SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdUbicacion() ) )
            {
                $s_SQLQuery .= $s_Separator."IdUbicacion = ".$this->getIdUbicacion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTipoDocumento = '".$this->getIdTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoCod() ) )
            {
                $s_SQLQuery .= $s_Separator."DocumentoCod = '".$this->getDocumentoCod()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoSerie() ) )
            {
                $s_SQLQuery .= $s_Separator."DocumentoSerie = '".$this->getDocumentoSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoNumero() ) )
            {
                $s_SQLQuery .= $s_Separator."DocumentoNumero = '".$this->getDocumentoNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery .= $s_Separator."IdPersona = ".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreCompleto() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreCompleto = '".$this->getNombreCompleto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoTotal() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoTotal = ".$this->getMontoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdUbicacionClienteH = ".$this->getIdUbicacionClienteH()." AND  NumeroDocumento = '".$this->getNumeroDocumento()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SRV_UbicacionClienteDet WHERE  IdUbicacionClienteH = ".$this->getIdUbicacionClienteH()." AND  NumeroDocumento = '".$this->getNumeroDocumento()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>